#!c:/perl/bin/perl

##############################################################################
# MTVWebdesign mailinglist manager (Arch)                        Version 2.0
# arch.cgi: The main script
# Copyright 1999-2000 Maarten Veerman mtveerman@mindless.com
# MTVWebdesign:    http://mtvwebdesign.hypermart.net/ (http://mtvwebdesign.hypermart.net/scripts/)
##############################################################################
# COPYRIGHT NOTICE
# Copyright 1999-2000 Maarten Veerman  All Rights Reserved.
#
# Arch may be used and modified so long as this
# copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Maarten Veerman from any liability that
# might arise from its use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program in any way.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium. In all cases copyright and header must remain intact
#
# Please send bug-reports to cgi-bugs@mtvwebdesign.hypermart.net
##############################################################################
#
# Script tested locally:
# Pentium 400Mhz, 128MB RAM, Windows 98, Apache 1.3.4 (win32), Perl, MS Internet Explorer 5.0, Netscape 4.05.
#
##############################################################################
# Please do not remove the following lines:
$scriptname = "Arch!";
$version = "2.0";
##############################################################################

# First we need to call some extra functions.
# Please note that you have to change the 2 "require" lines!
use CGI::Carp qw(fatalsToBrowser); # Provides you with fatal error message if they occur.
use CGI qw/:standard/;
require 'c:/sambar/htdocs/arch/arch.conf';
require $mtvwebdesignlib;
require $dbunderpath;
$dbdir = &dbdir_;
require $dbunder;

# The main routine
main: {
  &getinput;
  &GetCookies;
  &check_url;
  &purge_lists;
  
# Since we want to use the cookies with several scripts we need to set the
# cookie path. A lot of people might have problems with this, so we do it
# automatically.
  @paths = split(/\//, $ENV{'SCRIPT_NAME'});
  for ($I=1;$paths[$I+1] ne '';$I++) {
    $Cookie_Path .= "\/$paths[$I]";
  }
  
# Make sure the Database dir is really a dir.
  if ($db_dir !~ m/\/$/) { $db_dir = $db_dir . '/'; }
  
# All possible actions:
  if (lc $FORM{'action'} eq 'au') { &au; }
  elsif (lc $FORM{'action'} eq 'au2') { &au2; }
  
  elsif (lc $FORM{'action'} eq 'ru') { &ru; }
  elsif (lc $FORM{'action'} eq 'ru2') { &ru2; }
  
  elsif (lc $FORM{'action'} eq 'ml') { &ml; }
  elsif (lc $FORM{'action'} eq 'ml2') { &ml2; }
  elsif (lc $FORM{'action'} eq 'ml3') { &ml3; }
  
  elsif (lc $FORM{'action'} eq 'ml_options') { &ml_options; }
  elsif (lc $FORM{'action'} eq 'ml_options2') { &ml_options2; }
  
  elsif (lc $FORM{'action'} eq 'ml_main') { &ml_main; }
  elsif (lc $FORM{'action'} eq 'ml4') { &ml4; }
  elsif (lc $FORM{'action'} eq 'ml_changepass') { &ml_changepass; }
  elsif (lc $FORM{'action'} eq 'ml_changepass2') { &ml_changepass2; }
  
  elsif (lc $FORM{'action'} eq 'ce') { &ce; }
  elsif (lc $FORM{'action'} eq 'ce2') { &ce2; }
  
  elsif (lc $FORM{'action'} eq 'de') { &de; }
  
  elsif (lc $FORM{'action'} eq 'dml') { &dml; }
  elsif (lc $FORM{'action'} eq 'dml2') { &dml2; }
  
  elsif (lc $FORM{'action'} eq 'pm') { &pm; }
  elsif (lc $FORM{'action'} eq 'pm2') { &pm2; }
  
  elsif (lc $FORM{'action'} eq 'cnml') { &cnml; }
  elsif (lc $FORM{'action'} eq 'cnml2a') { &cnml2a; }
  elsif (lc $FORM{'action'} eq 'cnml2b') { &cnml2b; }
  elsif (lc $FORM{'action'} eq 'cnml3') { &cnml3; }
  
  elsif (lc $FORM{'action'} eq 'vi') { &vi; }
  
  elsif (lc $FORM{'action'} eq 'lp') { &lp; }
  elsif (lc $FORM{'action'} eq 'lp2') { &lp2; }
  elsif (lc $FORM{'action'} eq 'lp3') { &lp3; }
  
  elsif (lc $FORM{'action'} eq 'gen_html') { &gen_html; }
  
  elsif (lc $FORM{'action'} eq 'logout') { &logout("name,email,mln,lp"); }
  
  else { &mainpage; }
  exit;
  
}

sub get_name {
# Routine to get the simplified name of the list (lose some characters.)
  
  local($myname) = @_;
  
  $myname =~ s/\W//g;
  $filename = lc $myname;
  
}

sub mainpage {
  print "Content-type: text/html\n\n";
  &pageheader("Welcome to $servicename");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Welcome to $servicename</h2>
      Please select on of the following options:<p>
      <ol>
      <li><a href="$add_script?action=au">Subscribe to a mailing list.</a><br>
      <li><a href="$remove_script?action=ru">Unsubscribe from a mailing list.</a><br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=ml">Manage or create a mailing list.</a><br>
      </ol>
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit;
}

sub ml {
  &ml2 if $webmaster;
  print "Content-type: text/html\n\n";
  &pageheader("Manage a mailing list.");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Manage a mailing list</h2>
      Please select on of the following options.<p>
      <ol>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=ml2">Manage an existing mailing list</a> (Change options, Post a message to the list)<br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=cnml">Create a new mailing list</a>
      ~;
      
      print qq~
      <br>
      </ol>
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit;
}

sub cnml {
  if ($webmaster eq "0" || $Cookies{'loggedinwm'}) { &cnml2b; }
  else {
    print "Content-type: text/html\n";
    &expires_header("+10m");
    print "\n";
    &pageheader("Please enter the password");
    foreach $line (@temptoken) {
      if ($line =~ m/$token/i) {
        print qq~
        <h2>Login</h2>
        Only the webmaster can create a new mailing list.<p>
        <form action="$ENV{'SCRIPT_NAME'}" method="post">
        <input type="hidden" name="action" value="cnml2a">
        <input type="hidden" name="id" value="$id">
        Please enter the password: <input type="password" name="wp"><p>
        <input type="submit">
        </form>
        ~;
      }
      print "$line";
    }
    &powered_by("nologout");
    exit;
  }
}

sub cnml2a {
  if ($enc_web_pass) { $FORM{'wp'} = crypt($FORM{'wp'}, Mv); }
  if ($FORM{'wp'} eq $webmasterpass) {
    $Cookies{'loggedinwm'} = "1";
    &SetCookies("loggedinwm", "1");
    &cnml2b;
  }
  else {
    print "Content-type: text/html\n";
    &expires_header("now");
    print "\n";
    &pageheader("Please enter the password again");
    foreach $line (@temptoken) {
      if ($line =~ m/$token/i) {
        print qq~
        <h2>Login incorrect</h2>
        The password you provided was incorrect. Please try again. Only the webmaster can login.<p>
        <form action="$ENV{'SCRIPT_NAME'}" method="post">
        <input type="hidden" name="action" value="cnml2a">
        <input type="hidden" name="id" value="$id">
        Please enter the password: <input type="password" name="wp"><p>
        <input type="submit">
        </form>
        ~;
      }
      print "$line";
    }
    &powered_by("nologout");
    exit;
#}
  }
}

sub cnml2b {
# Do NOT delete the following line, or you'll get an enormous security problem!
  &cnml unless ($Cookies{'loggedinwm'} || $webmaster eq "0");
  
  print "Content-type: text/html\n";
  &expires_header("+5m");
  print "\n";
  &pageheader("Create a new mailing list");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Create a new mailing list</h2>
      Please fill out the form below, and you'll have your own mailing list.<br>
      Make sure your email address is correct, since the password for your list is sent to that address.
      <form action="$ENV{'SCRIPT_NAME'}" method="POST">
      <input type="hidden" name="action" value="cnml3">
      <input type="hidden" name="id" value="$id">
      <table cellpadding="5" cellspacing="0" border="1" align="center" width="50%">
      <tr><td>Please enter the name of your new mailing list:</td><td><input type="text" name="mln"></td></tr>
      <tr><td>Please enter your name:</td><td><input type="text" name="name" value="$Cookies{'name'}"></td></tr>
      <tr><td>Please enter your email address:</td><td><input type="text" name="email" value="$Cookies{'email'}"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit" value="Create the new MailingList!"></td></tr>
      </table>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub cnml3 {
# Do NOT delete the following line, or you'll get an enormous security problem!
  &cnml unless ($Cookies{'loggedinwm'} || $webmaster eq "0");
  
  while (($key,$value) = each %FORM) {
    $value =~ s/\//igs;
    $value =~ s/\|//igs;
    $FORM{$key} = $value;
  }
  
  $FORM{'name'} = "anonymous" unless $FORM{'name'};
  
  &check_email("$FORM{'email'}");
  &errors("mlnp") unless $FORM{'mln'};
  
  &get_name($FORM{'mln'});
  
  &opendb;
  &CreateTable_("main","lcname","realname","owner","email_of_owner","password","number_of_posts","footer","last_date_of_access","last_date_of_post","use","warned");
  &AddPrimaryKey_("main","lcname");
  
  %check = &BinarySelect_("main","$filename");
  
  if ($check{'lcname'}) { &closedb; &errors("mlnp"); }
  
  $days = $elapsed_seconds_newlist / (24 * 60 *  60);
  
  $pro_id = $$;
  
  &InsertIntoTable_("main","$filename","$FORM{'mln'}","$FORM{'name'}","$FORM{'email'}","$pro_id","0","","$timenow","","0","0");
  
  &closedb;
  
  open MAIL, $mailprog or die "Cannot sent out emails!!";
  print MAIL "From: $webmasteremail ($servicename)\n";
  print MAIL "To: $FORM{'email'} ($FORM{'name'})\n";
  print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign\n";
  print MAIL "Subject: Welcome to $servicename\n\n";
  print MAIL "Dear $FORM{'name'}\n\n";
  print MAIL "Thank you for creating a new mailing list. You list is almost ready.\nJust go to the following URL and login:\n";
  print MAIL "$loginlocation\n";
  print MAIL "Mailinglistname: $FORM{'mln'}\n";
  print MAIL "Password: $pro_id\n\n";
  print MAIL "Please note that if you do not login within $days days your list will be deleted.\n";
  print MAIL "We hope to see you again soon!\n";
  print MAIL " - $servicename\n\n";
  print MAIL "-" x 75 . "\n";
  print MAIL "This service is powered by a MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
  close MAIL;
  
  $Cookie_Exp_Date = "+6M";
  &SetCookies('name', $FORM{'name'}, 'email', $FORM{'email'}, 'mln', $FORM{'mnl'});
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("You have created a new list!");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Your new list is available!</h2>
      Please check your email for login information. Your list will automatically be activated the first time you login.<p>
      See you soon!
      <p>
      <a href="$servicelocation">Click here</a> to go back to the main page.
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
  
}

sub ml2 {
  print "Content-type: text/html\n";
  &expires_header("+5m");
  print "\n";
  &pageheader("Please provide login information");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Login</h2>
      Before you can access the special functions for your list, you'll need to login. Please provide the information as described in the welcome email.<p>
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="ml3">
      <input type="hidden" name="id" value="$id">
      <table cellpadding="5" cellspacing="0" width="50%" border="1">
      <tr><td>Please enter the name of your mailing list:</td><td><input type="text" name="mln" value="$Cookies{'mln'}"></td></tr>
      <tr><td>Please enter your password:</td><td><input type="password" name="password"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit"></td></tr>
      </table>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit;
}

sub ml2b {
  
  &opendb;
  @lists = &SelectFromTable_("main","AND","lcname,realname");
  &closedb;
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Problem with the listname");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>There is a problem with the listname.</h2>
      The list you provided does not exist ($FORM{'mln'}). Please try again by selecting your list from the drop-down menu. Do not forget to enter your password again!<p>
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="ml3">
      <input type="hidden" name="id" value="$id">
      <table cellpadding="5" cellspacing="0" width="50%" border="1">
      <tr><td>Please select the name of your mailing list:</td><td>
      <select name="mln">
      <option>Select a list
      ~;
      
      for ($x=0;$x < scalar @lists;$x++) {
        ($lcname,$realname) = split(/\/,$lists[$x]);
        print "<option value=\"$lcname\">$realname\n";
      }
      
      print qq~
      </select>
      </td></tr>
      <tr><td>Please enter your password:</td><td><input type="password" name="password"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit"></td></tr>
      </table>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by("nologout");
  exit; #Don't delete exit.....
}

sub ml3 {
# This sub checks if the list exists, if it's the first time here, if the password is correct.
  
  &get_name($FORM{'mln'});
  
  &opendb;
  
  %check = &BinarySelect_("main","$filename");
  
  if (!$check{'realname'}) { &closedb; &ml2b; }
  
  if ($FORM{'password'} ne $check{'password'}) { &closedb; &errors("password"); }
  
  &SetCookies("loggedin", "1");
  $Cookie_Exp_Date = "+6M";
  &SetCookies("mln", $check{'realname'});
  
  if ($check{'use'} eq "0") {$Cookies{'loggedin'} = "1"; $Cookies{'mln'} = $check{'realname'}; &ml3b;}
  else {$Cookies{'loggedin'} = "1"; $Cookies{'mln'} = $check{'realname'}; &ml4;}
  
}

sub ml3b {
  &ml2 unless ($Cookies{'loggedin'});
  
  &BinaryUpdate_("main","$filename","last_date_of_access=$timenow|use=1");
  
  &closedb;
  
  &ml_changepass("new");
  
}

sub ml_options {
  
  &ml2 unless ($Cookies{'loggedin'});
  
  &get_name($Cookies{'mln'});
  
  &opendb;
  %info = &BinarySelect_("main","$filename");
  &closedb;
  
  $info{'footer'} =~ s/<p>/\n\n/igs;
  $info{'footer'} =~ s/<br>/\n/igs;
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Options page");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      
      print qq~
      <h2>Options page</h2>
      This is the options page for $Cookies{'mln'} where you can change a few things. Just follow the instructions in the form. If you see pre-configured settings which you don't want to change, then just go to the next option.<p>
      <p>
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="ml_options2">
      <input type="hidden" name="id" value="$id">
      <hr noshade width="60%">
      <center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td>Your name:</td><td><input type="text" name="name" value="$info{'owner'}"></td></tr>
      </table>
      </center>
      <hr noshade width="60%">
      <center>
      <table cellpadding="5" cellspacing="0" border="1" width="50">
      <tr><th align="center">Footer</th></tr>
      <tr><td align="center">The footer is a piece of text which $servicename automatically places at the end of every post you send. When you post a message, you will also have the option not to include the footer. You'll see a checkbox on that page. It's easy to add a footer, since you won't have to retype all the info every time you post to your mailing list. Type it once, and we'll remember it for you!</td></tr>
      <tr><td><textarea name="footer" cols="50" rows="8">$info{'footer'}</textarea></td></tr>
      </table>
      </center>
      <hr noshade width="60%">
      <center>
      <input type="submit">
      </center>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub ml_options2 {
  
  &ml2 unless ($Cookies{'loggedin'});
  
  &get_name($Cookies{'mln'});
  
  $FORM{'name'} =~ s/\|//ig;
  $FORM{'name'} =~ s/\//ig;
  $FORM{'footer'} =~ s/\|//ig;
  $FORM{'footer'} =~ s/\//ig;
  $FORM{'footer'} =~ s/\n\n/<p>/ig;
  $FORM{'footer'} =~ s/\n/<br>/ig;
  
  &errors("no name") if ($FORM{'name'} eq '');
  
  &opendb;
  &BinaryUpdate_("main","$filename","owner=$FORM{'name'}|footer=$FORM{'footer'}");
  &closedb;
  
  &ml_main("Options changed");
  
}

sub ml_main {
  &ml2 unless ($Cookies{'loggedin'});
  local($message) = @_;
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("$Cookies{'mln'} managing page.");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Manage $Cookies{'mln'} here!</h2>
      ~;
      if ($message ne '') {
        print qq~
        <font color="#FF0000" size="+1">$message</font><p>
        ~;
      }
      print qq~
      Please choose one of the following options.<p>
      <ol>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=ml_options&id=$id">Set some options for the list</a><br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=pm&id=$id">Post a message to the list</a><br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=ml_changepass&id=$id">Change your password</a><br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=ce&id=$id">Change your email address</a><br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=vi&id=$id">View as much info on your list as possible</a><br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=gen_html&id=$id">Generate the HTML code for your webpage</a><br>
      <br>
      <li><a href="$ENV{'SCRIPT_NAME'}?action=dml&id=$id">Delete this mailing list</a><br>
      </ol>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub ml4 {
  &ml2 unless ($Cookies{'loggedin'});
  
  &BinaryUpdate_("main","$filename","last_date_of_access=$timenow");
  
  &closedb;
  
  &ml_main;
  
}

sub ml_changepass {
  &ml2 unless ($Cookies{'loggedin'});
  
  local($new) = @_;
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Change the password");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      if ($new eq "new") {
        print qq~
        <h2>Welcome to $servicename!</h2>
        The first thing you have to do is change the password and you can do that right here! Just fill out the form and hit the submit button.
        ~;
      }
      else {
        print qq~
        <h2>Change password for $Cookies{'mln'}<h2>
        ~;
      }
      print qq~
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="ml_changepass2">
      <input type="hidden" name="id" value="$id">
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td>Please enter your old password:</td><td><input type="password" name="oldpass"></td></tr>
      <tr><td>Please enter your new password:</td><td><input type="password" name="newpass1"></td></tr>
      <tr><td>Please enter your new password again:</td><td><input type="password" name="newpass2"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit"></td></tr>
      </table>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub ml_changepass2 {
  &ml2 unless ($Cookies{'loggedin'});
  
  &ml2 unless $Cookies{'mln'};
  
  $FORM{'newpass1'} =~ s/\|//ig;
  $FORM{'newpass1'} =~ s/\//ig;
  &errors("newpass") if ($FORM{'newpass1'} ne $FORM{'newpass2'});
  &errors("oldpass") unless $FORM{'oldpass'};
  &ml2 unless $Cookies{'mln'};
  
  &get_name("$Cookies{'mln'}");
  
  &opendb;
  
  %info =  &BinarySelect_("main","$filename");
  
  if ($info{'password'} ne $FORM{'oldpass'}) {
    &closedb;
    &errors("oldpass");
  }
  
  &BinaryUpdate_("main","$filename","password=$FORM{'newpass1'}");
  
  &closedb;
  
  &ml_main("Password successfully changed!");
  
}

sub ce {
# Change emailaddress
  &ml2 unless ($Cookies{'loggedin'});
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Change emailaddress");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Change email address</h2>
      Please note: If you decide to change your email address we automatically change your password too, and mail the new password to your new email address. We do this, so we can track you if we get complaints about spam. Sorry, but there is nothing we can do about it.<br>
      If you still want to change your email address, please fill out the form, otherwise click the back button in your browser.
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="ce2">
      <input type="hidden" name="id" value="$id">
      <center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td>Please enter your new email address:</td><td><input type="text" name="newemail"></td></tr>
      <tr><td colspan="2" align="center"><input type="submit"></td></tr>
      </table>
      </center>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub ce2 {
  &ml2 unless ($Cookies{'loggedin'});
  
  $newpass = $$;
  
  &check_email($FORM{'newemail'});
  &get_name($Cookies{'mln'});
  
  &opendb;
  %data = &BinarySelect_("main","$filename");
  &BinaryUpdate_("main","$filename","email_of_owner=$FORM{'newemail'}|password=$newpass");
  &closedb;
  
  open MAIL, $mailprog or die "Cannot sent out emails!!";
  print MAIL "From: $webmasteremail ($servicename)\n";
  print MAIL "To: $FORM{'newemail'} ($data{'owner'})\n";
  print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign\n";
  print MAIL "Subject: New password\n\n";
  print MAIL "Dear $data{'owner'}\n\n";
  print MAIL "As you have changed your email address, we have changed your password. Here is your new password. Please login at:\n";
  print MAIL "$loginlocation\n";
  print MAIL "Mailinglistname: $Cookies{'mln'}\n";
  print MAIL "Password: $newpass\n\n";
  print MAIL "We hope to see you again soon!\n";
  print MAIL " - $servicename\n\n";
  print MAIL "-" x 75 . "\n";
  print MAIL "This service is powered by a MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
  close MAIL;
  
  $Cookie_Exp_Date = "now";
  &SetCookies('loggedin', 0);
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Email changed");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Email address changed!</h2>
      Your email address has been changed succesfully. Please check your email for your new password.
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub dml {
# Delete the list
  &ml2 unless ($Cookies{'loggedin'});
  
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("Delete the mailing list");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Delete the mailing list</h2>
      When you delete your mailing list, you delete everything, including the file which holds all subscribers. Once deleted, the listname becomes available, and free for other people to use!<br>
      Are you sure you want to delete the following mailing list: <b>$Cookies{'mln'}</b>?<p>
      <form action="$ENV{'SCRIPT_NAME'}" method="post">
      <input type="hidden" name="action" value="dml2">
      <input type="hidden" name="id" value="$id"><center>
      <table cellpadding="5" cellspacing="0" border="1">
      <tr><td><input type="submit" name="dl" value="Yes"></td><td><input type="submit" name="dl" value="No"></td></tr>
      </table></center>
      </form>
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub dml2 {
  &ml2 unless ($Cookies{'loggedin'});
  
  &ml_main if lc $FORM{'dl'} eq "no";
  exit if lc $FORM{'dl'} eq "no";
  
  &get_name($Cookies{'mln'});
  
  &opendb;
  &DeleteFromTable_("main","AND","lcname|eq|$filename");
  &DeleteFromTable_("addresses","AND","listname|eq|$filename");
  &closedb;
  
  $Cookie_Exp_Date = "now";
  &SetCookies('loggedin', 0);
  print "Content-type: text/html\n";
  &expires_header("now");
  print "\n";
  &pageheader("List deleted");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>List deleted</h2>
      Your mailing list has been deleted. Thank you for using $servicename!
      ~;
    }
    print "$line";
  }
  &powered_by;
  exit;
}

sub vi {
# View Info
  &ml2 unless ($Cookies{'loggedin'});
  
  &get_name($Cookies{'mln'});
  
  &opendb;
  %info = &BinarySelect_("main","$filename");
  @addresses = &SelectFromTable_("addresses","AND","username,email","listname|eq|$filename");
  &closedb;
  
  print "Content-type: text/html\n";
  &expires_header("+5m");
  print "\n";
  &pageheader("Information for $Cookies{'mln'}");
  foreach $line (@temptoken) {
    if ($line =~ m/$token/i) {
      print qq~
      <h2>Information for $Cookies{'mln'}</h2>
      You'll find as much information as possible here about your list. This is the way your information is stored in our databases.
    If you see things which aren't correct, you can change them on the <a href="$ENV{'SCRIPT_NAME'}?action=ml_main&id=$id">manage page</a>.<p>
    <hr noshade>
    Name of the mailing list: <b>$info{'realname'}</b><br>
    Name of owner: <b>$info{'owner'}</b><br>
    Email of owner: <b>$info{'email_of_owner'}</b> (<a href="$ENV{'SCRIPT_NAME'}?action=ce&id=$id">Change</a>)<br>
    ~;
    
    if ($info{'footer'} ne '') {
      $info{'footer'} =~ s/\n/<br>/ig;
      print qq~
      Footer: (<a href="$ENV{'SCRIPT_NAME'}?action=ml_options&id=$id">change</a>)<br><b>$info{'footer'}</b><p>
      ~;
    }
    else {
      print qq~
      No footer is provided. <a href="$ENV{'SCRIPT_NAME'}?action=ml_options&id=$id">Click here </a>to set one.<p>
      ~;
    }
    
    if ($info{'number_of_posts'} > 0) {
      print qq~
      Number of posts: <b>$info{'number_of_posts'}</b><br>
      Date of last post: <b>$info{'last_date_of_post'}</b><p>
      ~;
    }
    else {
      print qq~
      You never posted a message to the list.<p>
      ~;
    }
    
    print qq~
    <hr noshade>
    <h3>Domains</h3>
    Here is a list of all the domains your subscribers come from:
    <center>
    <table cellpadding="5" cellspacing="0" border="1">
    <tr><td><b>Number</b></td><td><b>Domain</b></td></tr>
    ~;
    
    for ($e=1;$e < scalar @addresses;$e++) {
      ($username,$email) = split(/\/,$addresses[$e]);
      @email = split(/\./,$email);
      if ($hash{$email[$#email]}) { $hash{$email[$#email]}++; }
          else { $hash{$email[$#email]} = 1; }
            }
            
            
            foreach $domain (sort %hash) {
              if ($hash{$domain} ne '') {
                print "<tr><td align=\"center\">" . $hash{$domain} . "</td><td align=\"center\">." . $domain . "</td></tr>";
              }
            }
            
            print qq~
            </table>
            </center>
            <hr noshade>
            <h3>Subscribers</h3>
            Here is the list of subscribers to your mailing list:<p>
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="de">
            <input type="hidden" name="id" value="$id">
            <center>
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td>&nbsp;</td><td align="center"><b>Name of subscriber</b></td><td align="center"><b>Email of subscriber</b></td></tr>
            ~;
            
            for ($s=1; $s < scalar @addresses;$s++) {
              ($username,$email) = split(/\/,$addresses[$s]);
              print "<tr><td align=\"center\"><input type=\"checkbox\" name=\"eos\" value=\"$email\"></td><td align=\"center\">$username</td><td align=\"center\"><a href=\"mailto:$email\">$email</a></td></tr>\n";
            }
            
            print qq~
            <tr><td colspan="3" align="center"><input type="submit" value="Delete selected email addresses"></td></tr>
            </table>
            </center>
            </form>
            ~;
            
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub de {
        &ml2 unless $Cookies{'loggedin'};
# Delete email addresses.
        
        &get_name($Cookies{'mln'});
        
        @emails = split(/,/,$FORM{'eos'});
        
        &opendb;
        for ($d=0; $d < scalar @emails; $d++) {
          &DeleteFromTable_("addresses","AND","listname|eq|$filename","email|eq|$emails[$d]");
        }
        &closedb;
        
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader("Addresses deleted");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Addresses deleted.</h2>
            The following addresses have been deleted:<p>
            ~;
            
            foreach $ad (@emails) {
              print "$ad<br>";
            }
            
            print qq~
            <p>
            <a href="$ENV{'SCRIPT_LOCATION'}?action=vi&id=$id">Click here</a> to get back to the info page, or <a href="$ENV{'SCRIPT_NAME'}?action=ml_main&id=$id">click here</a> to go back to the main page.
            ~;
            
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub gen_html {
        &ml2 unless $Cookies{'loggedin'};
# Generate the html code for the use on peoples webpages.
        
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader("Your HTML code");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>HTML code for $Cookies{'mln'}</h2>
            You can choose between 2 different types of codes.
            <ol>
            <li>The first one is a link to a page we will generate for you. Your visitors click on the link, and we sent them to a generated page which has your listname pre-configured. Very simple.
            <li>The second one is a real form. You can place the form on your own site, and use your own layout for the page it is on. This one has the additional option to send people to a specified webpage after the information is submitted.
            </ol>
            <hr noshade width="60%">
            <h3>Code 1</h3>
            <b>Example:</b><br>
            <a href="$add_script?action=au&mln=My Mailing List">Click here</a> to join my mailing list!<br>
            <a href="$remove_script?action=ru&mln=My Mailing List">Click here</a> to remove yourself from my mailing list.<br>
            <br>
            Insert the following lines in your HTML code if you want to use this code. Please note that you can change the text to an image, by placing an image tag at the place where you find "Click here".<p>
            <center>
            <table bgcolor="#FFFFB9" cellpadding="5" cellspacing="0" border="1">
            <tr><td><b>To add a user:</b></td><td>&lt;a href=&quot;$add_script?action=au&mln=$Cookies{'mln'}&quot;&gt;Click here&lt;/a&gt; to add yourself to my mailing list!</td></tr>
            <tr><td><b>To remove a user:</b></td><td>&lt;a href=&quot;$remove_script?action=ru&mln=$Cookies{'mln'}&quot;&gt;Click here&lt;/a&gt; to remove yourself from my mailing list.</td></tr>
            </table>
            </center>
            <hr noshade width="60%">
            <h3>Code 2</h3>
            <b>Example:</b><br>
            Add yourself to my mailing list. Please fill out the form:<br>
            <form action="$add_script" method="post">
            <input type="hidden" name="action" value="au2">
            <input type="hidden" name="mln" value="$Cookies{'mln'}">
            <!-- You can send people to a specific URL if you by using the following input tag: -->
            <input type="hidden" name="sent_to" value="YOUR_URL_HERE">
            <!-- an URL always starts with http:// -->
            <center>
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td>Please enter your name:</td><td><input type="text" name="name"></td></tr>
            <tr><td>Please enter your email address:</td><td><input type="text" name="email"></td></tr>
            <tr><td colspan="2" align="center"><input type="submit"></td></tr>
            </table></center>
            </form>
            <p>
            Unsubscribe from our mailing list. Please fill out the form:<br>
            <form action="$remove_script" method="post">
            <input type="hidden" name="action" value="ru2">
            <input type="hidden" name="mln" value="$Cookies{'mln'}">
            <!-- You can send people to a specific URL if you by using the following input tag: -->
            <input type="hidden" name="sent_to" value="YOUR_URL_HERE">
            <!-- an URL always starts with http:// -->
            <center>
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td>Please enter your email address:</td><td><input type="text" name="email"></td></tr>
            <tr><td colspan="2" align="center"><input type="submit"></td></tr>
            </table>
            </form>
            <p>
            <center>
            <table bgcolor="#FFFFB9" cellpadding="5" cellspacing="0" border="1">
            <tr><td><b>To add a user:</b></td><td>
            Join my mailing list. Please fill out the form:&lt;br&gt;<br>
            &lt;form action="$add_script" method="post"&gt;<br>
            &lt;input type="hidden" name="action" value="au2"&gt;<br>
            &lt;input type="hidden" name="mln" value="$Cookies{'mln'}"&gt;<br>
            &lt;!-- You can send people to a specific URL if you by using the following input tag: --&gt;<br>
            &lt;input type="hidden" name="sent_to" value="YOUR_URL_HERE"&gt;<br>
            &lt;!-- an URL always starts with http:// --&gt;<br>
            &lt;center&gt;<br>
            &lt;table cellpadding="5" cellspacing="0" border="1"&gt;<br>
            &lt;tr&gt;&lt;td&gt;Please enter your name:&lt;/td&gt;&lt;td&gt;&lt;input type="text" name="name"&gt;&lt;/td&gt;&lt;/tr&gt;<br>
            &lt;tr&gt;&lt;td&gt;Please enter your email address:&lt;/td&gt;&lt;td&gt;&lt;input type="text" name="email"&gt;&lt;/td&gt;&lt;/tr&gt;<br>
            &lt;tr&gt;&lt;td colspan="2" align="center"&gt;&lt;input type="submit"&gt;&lt;/td&gt;&lt;/tr&gt;<br>
            &lt;/table&gt;&lt;/center&gt;<br>
            &lt;/form&gt;<br>
            </td></tr>
            <tr><td><b>To remove a user:</b></td><td>
            Unsubscribe from our mailing list. Please fill out the form:&lt;br&gt;<br>
            &lt;form action="$remove_script" method="post"&gt;<br>
            &lt;input type="hidden" name="action" value="ru2"&gt;<br>
            &lt;input type="hidden" name="mln" value="$Cookies{'mln'}"&gt;<br>
            &lt;!-- You can send people to a specific URL if you by using the following input tag: --&gt;<br>
            &lt;input type="hidden" name="sent_to" value="YOUR_URL_HERE"&gt;<br>
            &lt;!-- an URL always starts with http:// --&gt;<br>
            &lt;center&gt;<br>
            &lt;table cellpadding="5" cellspacing="0" border="1"&gt;<br>
            &lt;tr&gt;&lt;td&gt;Please enter your email address:&lt;/td&gt;&lt;td&gt;&lt;input type="text" name="email"&gt;&lt;/td&gt;&lt;/tr&gt;<br>
            &lt;tr&gt;&lt;td colspan="2" align="center"&gt;&lt;input type="submit"&gt;&lt;/td&gt;&lt;/tr&gt;<br>
            &lt;/table&gt;<br>
            &lt;/form&gt;<br>
            </td></tr>
            </table>
            </center>
            ~;
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub pm {
        local($mess) = @_;
        &ml2 if !$Cookies{'loggedin'};
        
        &get_name($Cookies{'mln'});
        
        &opendb;
        %info = &BinarySelect_("main","$filename");
        &closedb;
        
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader("Post a message");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Post a message to the $Cookies{'mln'} mailing list</h2>
            ~;
            
            if ($mess) {
              print qq~
              <font color="#FF0000"><b>$mess</b></font><p>
              ~;
            }
            
            print qq~
            Please fill out the form below to sent the message.<p>
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="pm2">
            <input type="hidden" name="id" value="$id">
            <center>
            <table cellpadding="5" cellspacing="0" border="1" width="100%">
            <tr><td align="center"><b>Subject:</b></td><td align="center"><input type="text" name="subject" size="45" maxlength="100" value="$FORM{'subject'}"></td></tr>
            <tr><td align="center"><b>Please select the opening line:</b></td><td align="center">
            <select name="opening">
            <option value="Dear">Dear NAME,
            <option value="Hello">Hello NAME,
            <option value="Hi">Hi NAME,
            </select>
            </td></tr>
            <tr><td align="center" colspan="2"><b>The body of the email:</b> (Please don't forget your name at the end.)</td></tr>
            <tr><td align="center" colspan="2"><textarea name="text" cols="50" rows="10">$FORM{'text'}</textarea></td></tr>
            ~;
            
            if ($info{'footer'} ne '') {
              print qq~
              <tr><td align="center" colspan="2"><b>Please check this box if you want to add the footer to the end of the email: </b><input type="checkbox" name="add_footer" value="yes" checked></td></tr>
              ~;
            }
            
            print qq~
            <tr><td align="center" colspan="2"><font color="#FF0000">Click only once!</font><br><input type="submit" value="Post the message!"></td></tr>
            </table>
            </center>
            </form>
            ~;
          }
          print "$line";
        }
        &powered_by;
        exit;
      }
      
      sub pm2 {
        &ml2 if !$Cookies{'loggedin'};
        
        &pm("Please enter a subject") if !$FORM{'subject'};
        &pm("Please enter some text for the body of the email!") if !$FORM{'text'};
        
        &getdate;
        
        &get_name($Cookies{'mln'});
        
        &opendb;
        %info = &BinarySelect_("main","$filename");
        $num = $info{'number_of_posts'};
        $num++;
        &BinaryUpdate_("main","$filename","number_of_posts=$num|last_date_of_post=$date");
        @addresses = &SelectFromTable_("addresses","AND","username,email","listname|eq|$filename");
        &closedb;
        
        for($u=1;$u < scalar @addresses;$u++) {
          
          ($username,$email) = split(/\/,$addresses[$u]);

$FORM{'text'} =~ s/\r//igs;
$IP = $ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'};
          
          open MAIL, $mailprog || die "Cannot open $mailprog and cannot sent emails";
          print MAIL "From: $info{'email_of_owner'} ($info{'owner'}, manager of the $info{'realname'} mailing list!)\n";
          print MAIL "To: $email ($username)\n";
print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign [IP of sender: $IP]\n";
          print MAIL "Subject: $FORM{'subject'}\n\n";
          print MAIL "$FORM{'opening'} $username,\n\n";
          print MAIL $FORM{'text'};
          
          if ($FORM{'add_footer'}) {
            $info{'footer'} =~ s/<p>/\n\n/igs;
            $info{'footer'} =~ s/<br>/\n/igs;
            print MAIL "\n";
            print MAIL $info{'footer'};
          }
          
          print MAIL "\n\n";
          print MAIL "To unsubscribe from this mailing list, please click here:\n";
          print MAIL "$remove_script?action=ru2&email=$email&mln=$filename\n\n";
          print MAIL "-" x75 . "\n";
          print MAIL "$servicename is powered by a MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
          print MAIL "Get your own mailing list at $servicelocation\n";
          close MAIL;
        }
        
        open MAIL, $mailprog || die "Cannot open $mailprog and cannot sent emails";
        print MAIL "From: $info{'email_of_owner'} ($info{'owner'}, manager of the $info{'realname'} mailing list!)\n";
        print MAIL "To: $info{'email_of_owner'} ($info{'owner'})\n";
        print MAIL "Subject: (copy) $FORM{'subject'}\n\n";
        print MAIL "$FORM{'opening'} $info{'owner'},\n\n";
        print MAIL "This is a copy of the email sent to all your subscribers.\n\n";
        print MAIL $FORM{'text'};
        
        if ($FORM{'add_footer'}) {
          print MAIL "\n";
          print MAIL $info{'footer'};
        }
        
        print MAIL "\n\n";
        print MAIL "-" x75 . "\n";
        print MAIL "Get your own mailing list at $servicelocation\n";
        close MAIL;
        
        &ml_main("Your message has been posted to the mailing list!");
        
      }
      
      sub purge_lists {
#$newlist_time, $warning_time, $oldlist_time
        
        &opendb;
        
        @data =  &SelectFromTable_("main","AND","lcname","use|eq|0","last_date_of_access|<|$newlist_time");
        for($a=1;$a < scalar @data;$a++) {
          &DeleteFromTable_("main","AND","use|eq|0","last_date_of_access|<|$newlist_time");
          &DeleteFromTable_("addresses","AND","listname|eq|$data[$a]");
        }
        
        @data =  &SelectFromTable_("main","AND","lcname,realname,owner,email_of_owner","use|eq|1","last_date_of_access|<|$warning_time","warned|eq|0");
        for ($a=1;$a < scalar @data;$a++) {
          ($lcname,$realname,$owner,$email_of_owner) = split(/\/,$data[$a]);
          &UpdateTableSet_("main","AND","warned=1","lcname|eq|$lcname");
        }
        
        @data =  &SelectFromTable_("main","AND","lcname","use|eq|1","last_date_of_access|<|$oldlist_time");
        for($a=1;$a < scalar @data;$a++) {
          &DeleteFromTable_("main","AND","lcname|eq|$data[$a]");
          &DeleteFromTable_("addresses","AND","listname|eq|$data[$a]");
        }
        
        
        &closedb;
        
      }
      
      sub warn {
        
        $calc_time = ($warning_time - $oldlist_time) / (60 * 60 * 24);
        
        open MAIL, "$mailprog" || die "Cannot open $mailprog cannot sent mails";
        print MAIL "To: $email_of_owner ($owner)\n";
        print MAIL "From: $webmasteremail ($servicename)\n";
        print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign\n";
        print MAIL "Subject: Your $realname mailing list is about to be deleted\n\n";
        print MAIL qq~
        Dear $owner,
        
        Your $realname mailing list is about to be deleted. You have $calc_time days left to start using your list again.
        Please note that just logging in is enough to save your list.
        
        Go to the following location to login:
        $loginlocation
        
        If you have lost your password, we can help you there too.
        
        Hope to see you soon!
        
        $servicename
        ~;
        print MAIL "\n\n";
        print MAIL "-" x 75 . "\n";
        print MAIL "$servicename is powered by an MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
        close MAIL;
        
      }
      
      sub lp {
        
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader("Lost your password?");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Lost your password?</h2>
            Please fill out the form below and we'll send your password to the email address which we find in our databases.<p>
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="lp2">
            <input type="hidden" name="id" value="$id">
            <center>
            <table cellpadding="5" cellspacing="0" border="1">
            <tr><td>Please enter the name of your list:</td><td><input type="text" name="mln" value="$Cookies{'mln'}"></td></tr>
            <tr><td colspan="2" align="center"><input type="submit"></td></tr>
            </table>
            </center>
            </form>
            ~;
          }
          print "$line";
        }
        &powered_by("nologout");
        exit;
      }
      
      sub lp2 {
        
        &lp4 if $Cookies{'lp'};
        
        &get_name($FORM{'mln'});
        
        &opendb;
        %info = &BinarySelect_("main","$filename");
        &closedb;
        
        &lp3 unless $info{'realname'};
        
        open MAIL, "$mailprog" || die "Cannot sent mail";
        print MAIL "To: $info{'email_of_owner'} ($info{'owner'})\n";
        print MAIL "From: $webmasteremail ($servicename)\n";
        print MAIL "X-Mailer: $servicename, the ultimate mailinglist manager by MTVWebdesign\n";
        print MAIL "Subject: Your password for the $info{'realname'} mailing list\n\n";
        print MAIL qq~
        Dear $info{'owner'},
        
        As you requested here is your password reminder for the $info{'realname'} mailing list:
        $info{'password'}
        
        Please go to the following URL to login:
        $loginlocation
        
        Yours,
        $webmastername
        ~;
        print MAIL "\n\n";
        print MAIL "-" x 75 . "\n";
        print MAIL "$servicename is powered by an MTVWebdesign script\nhttp://mtvwebdesign.hypermart.net\n";
        close MAIL;
        
        $Cookie_Exp_Date = "+5d";
        &SetCookies("lp", $jaja[1]);
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader("Password emailed to you");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Password has been emailed</h2>
            The password for <b>$info{'realname'}</b> has been sent to <b>$info{'email_of_owner'}</b>. Please check your email!
            ~;
          }
          print "$line";
        }
        &powered_by("nologout");
        exit;
        
      }
      
      sub lp3 {
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";;
        &pageheader("Problem with the mailing list name");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Problem with mailinglist name</h2>
            There is a problem with the name you provided: <b>$FORM{'mln'}</b>.<Br>
            There is no such list.
            Please select your list from the list below:
            <form action="$ENV{'SCRIPT_NAME'}" method="post">
            <input type="hidden" name="action" value="lp2">
            <input type="hidden" name="id" value="$id">
            <select name="mln"><option value="">Select a list
            ~;
            
            &opendb;
            @lists = &SelectFromTable_("main","AND","lcname,realname");
            &closedb;
            
            for($l=1;$l < scalar @lists;$l++) {
              ($lcname,$realname) = split(/\/,$lists[$l]);
              print "<option value=\"" . $lcname . "\">" . $realname . "\n";
            }
            
            print qq~
            </select>
            <input type="submit">
            </form>
            ~;
            
          }
          print "$line";
        }
        &powered_by("nologout");
        exit;
      }
      
      sub lp4 {
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader("Error");
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            print qq~
            <h2>Error</h2>
            There is a problem with your request. We have already sent you the password for $Cookies{'lp'}. You cannot request another password reminder within the next 5 days, for security reasons.
            ~;
          }
          print "$line";
        }
        &powered_by("nologout");
        exit;
      }
      
      sub getdate {
        
        @months=("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
        "Aug", "Sep", "Oct", "Nov", "Dec");
        ($sec, $min, $hour, $mday, $mon, $year) = localtime($^T);
        $mon = $months[$mon];
        $year = $year + 1900;
        $date = "$mday $mon $year";
        
      }
      
      sub errors {
        local($errors) = @_;
        
        print "Content-type: text/html\n";
        &expires_header("now");
        print "\n";
        &pageheader('An error occured');
        foreach $line (@temptoken) {
          if ($line =~ m/$token/i) {
            if ($errors eq 'with the email address you gave') {
              print qq~
              <h2>Invalid email address</h2>
              The following email address is invalid: $invalidmail<br>
              Please press the back button and try again.
              ~;
            }
            elsif ($errors eq 'mlnp') {
              print qq~
              <h2>Mailing List name problem</h2>
              I'm sorry, but there is a problem with the mailing list name. Either you didn't provide a mailing list name at all, or the name is already taken by someone else.<br>
              Please try again.
              ~;
            }
            
            elsif ($errors eq 'password') {
              print qq~
              <h2>Password problem</h2>
            I'm sorry, but there seems to be a problem with the password you provided. Lost your password? <a href="$ENV{'SCRIPT_NAME'}?action=lp">Click here!</a> Otherwise please try again.
            ~;
          }
          
          elsif ($errors eq 'oldpass') {
            print qq~
            <h2>Password problem</h2>
            I'm sorry, but there seems to be a problem with the old password you provided. Please try again.
            ~;
          }
          
          elsif ($errors eq 'newpass') {
            print qq~
            <h2>Password problem</h2>
            I'm sorry, but there seems to be a problem with the new password you provided. Either you didn't provide a new password at all, or the 2 passwords did not correspond.<br>Please try again.
            ~;
          }
          
          elsif ($errors eq 'not removed') {
            print qq~
            <h2>Not removed</h2>
            I'm sorry but you cannot be removed from the $info{'realname'} mailing list, since you aren't in the database. Please check your email address.
            ~;
          }
          
          elsif ($errors eq 'no name') {
            print qq~
            <h2>No name provided</h2>
            You forgot to enter your name. Please try again.
            ~;
          }
          
# If the error type was not found:
          else {
            print qq~
            Error Undefined! Please contact <a href="mailto:$webmasteremail?subject=Error_Undefined">$webmasteremail</a> and give details as to what may have caused the error.
            ~;
          }
          
# Back button:
          print qq~
          <center><FORM><INPUT type="button" value="Back" onClick="history.go(-1)"></FORM></center>
          ~;
        }
        print "$line";
      }
      &powered_by;
      exit; # Exit the script when an error occured.
    }
    
    sub opendb {
      &LockAndOpen_("","Arch");
      &CreateDatabase_;
    }
    
    sub closedb {
      &UnlockAndCommit_;
    }
